package testwsse.bookstore.auth.clientsample;

import java.util.List;

import javax.xml.ws.BindingProvider;
import org.apache.cxf.ws.security.SecurityConstants;

import testwsse.bookstore.auth.*;


public class ClientSample {

	public static void main(String[] args) throws java.lang.Exception {
	        System.out.println("***********************");
	        System.out.println("Create Web Service Client...");
	        Bookstore_Service service1 = new Bookstore_Service();
	        System.out.println("Create Web Service...");
	        Bookstore port1 = service1.getCartServicePort();
	        
	        System.out.println("Configuring WS-Security...");	        
	        
	        //XXX won't work
	        ((BindingProvider)port1).getRequestContext().put(SecurityConstants.USERNAME, "soatest");
	        ((BindingProvider)port1).getRequestContext().put(SecurityConstants.PASSWORD, "soatest");
	        
	        //XXX won't work either, callback is never called
	        //((BindingProvider)port1).getRequestContext().put(SecurityConstants.USERNAME, "soatest");
	        //((BindingProvider)port1).getRequestContext().put(SecurityConstants.CALLBACK_HANDLER,
	        //      "testws.bookstore.auth.clientsample.UsernamePasswordCallback");
	        

	        System.out.println("Call Web Service Operation...");
	        
	        List<Book> livros = port1.getItemByTitle("Java");
	        System.out.println("Found: " + livros.size() + " books.");
	        for (Book livro : livros) {
	        	System.out.println("Book Title: " + livro.getName());
	        	for (String autor: livro.getAuthors()) {
		        	System.out.println("Author: " + autor);
	        	}
	        }
	        
	        System.out.println("***********************");
	        System.out.println("Call Over!");
	}
}